//
// file :         readthread.h
//
// description :  reading thread
//
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//


#ifndef RAMPTHREAD_H
#define RAMPTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <inttypes.h>

namespace CCDSpectrometer_ns
{

class readthread : public omni_thread, public Tango::TangoMonitor, public Tango::LogAdapter
{	
	private:
		Tango::DeviceImpl* device;
		void abort_sleep(double time); 
		Tango::DevLong last_camera_counter;
		int wait_counter;

		bool use_last_fit;

		unsigned long old_bunch_number;

		bool just_reconnected;

		uint32_t numavg;
		int PrepareMeas();
		int Measure(double *l_pSpectrum);

		void StopMeas();
		int Heartbeat();
				
	public:
		readthread(Tango::DeviceImpl* devImpl);
		~readthread();
		int pausesec,pausenano;
		double min_fit_time;
		double max_fit_time;
		double tot_fit_time;
		double avg_fit_time;
		size_t fit_counter;
		bool abortflag;
		bool waitflag;
					
	protected:
		void run(void *);
		
};	/* end class readthread() */

}

#endif

/* EOF */
